#include <dos.h>
#include <tchrt.h>
#include <extmem.h>


main()
{

  unsigned long hits, elapsed;
  unsigned long source, dest;
  int indx;
  float rate;

printf("There is %i Kb of extended memory available",e_avail());

 e_meminit();



printf ("\nThe gdt is at %Fp",(void far *)&gdt);
  t_start();


/* here is how to convert the seg:off to an absolute 24 bit address */

source = (long) FP_SEG((void far *)&gdt) << 4;	/* shift the segment left 4 bits*/
source += FP_OFF((void far *)&gdt);		/* add the offset */


dest = 0x110000;				/* 2nd 64k segment above 1 meg*/
						/* THIS WILL BLOW UP YOUR */
						/* RAM DISK !!!!!!! */



printf ("\nThe source is at 0x%lx and the destination is at 0x%lx",source,dest);

for (indx=0;indx<1000;indx++)
{
  t_entry(0);
  e_memmove(source, dest, 0x8000);
  t_exit(0);
}


t_stop();
t_ask_timer(0,&hits, &elapsed);

rate = (65536.0*hits)/elapsed;
printf ("\nThere were %lu cycles", hits);

rate =elapsed;
 printf("\nThe time in milliseconds is %lu",elapsed);

rate = ((65536.0*hits)/rate);
printf ("\nThe data transfer rate is %f megabytes per second",rate);


}/* end main */




int e_memmove(long unsigned source, long unsigned dest, unsigned count)
{


/********************************************************/
/*							*/
/*		Move Extended Memory Block		*/
/*							*/
/*	Receives: unsigned long source and destination	*/
/*		  unsigned int count of WORDS to move   */
/*		      count must be <= 0x8000		*/
/*							*/
/*	Returns:  zero  = move seemed good 		*/
/*		  0x100 = ram parity error		*/
/*		  0x200 = other exceptin error		*/
/*		  0x300 = Gate address line 20 failed	*/
/*							*/
/*	Globals used: Structure extm_gdt, variable gdt	*/
/*							*/
/********************************************************/

gdt.segment_s = (char) (source >> 16);
gdt.segment_d = (char) (dest   >> 16);
gdt.offset_s =  (int)  (source);
gdt.offset_d =  (int)  (dest);

_SI=FP_OFF((void far *) &gdt);
_ES=FP_SEG((void far *) &gdt);
_CX=count;
_AX=0x8700;

geninterrupt(0x15);
}





int e_avail(void)
{
/********************************************************/
/*							*/
/*		Get Extended Memory Size		*/
/*							*/
/*	Receives:  VOID					*/
/*							*/
/*	Returns:   number of Kbytes available		*/
/*							*/
/*	Globals used: None				*/
/*							*/
/********************************************************/
  _AH=0x88;
  geninterrupt(0x15);
}





void e_meminit(void)
{
/********************************************************/
/*							*/
/*	Initialize the Global Descriptor Structure	*/
/*							*/
/*	Receives: VOID					*/
/*							*/
/*	Returns:  VOID					*/
/*							*/
/*	Globals used: GDT structure			*/
/*							*/
/********************************************************/

  gdt.length_s = 0xffff;
  gdt.access_s = 0x93;
  gdt.tail_s   = 0;

  gdt.length_d = 0xffff;
  gdt.access_d = 0x93;
  gdt.tail_d   = 0;

}