
int e_memmove(long unsigned source, long unsigned dest, unsigned count)
{


/********************************************************/
/*							*/
/*		Move Extended Memory Block		*/
/*							*/
/*	Receives: unsigned long source and destination	*/
/*		  unsigned int count of WORDS to move   */
/*		      count must be <= 0x8000		*/
/*							*/
/*	Returns:  zero  = move seemed good 		*/
/*		  0x100 = ram parity error		*/
/*		  0x200 = other exceptin error		*/
/*		  0x300 = Gate address line 20 failed	*/
/*							*/
/*	Globals used: Structure extm_gdt, variable gdt	*/
/*							*/
/********************************************************/

gdt.segment_s = (char) (source >> 16);
gdt.segment_d = (char) (dest   >> 16);
gdt.offset_s =  (int)  (source);
gdt.offset_d =  (int)  (dest);

_SI=FP_OFF((void far *) &gdt);
_ES=FP_SEG((void far *) &gdt);
_CX=count;
_AX=0x8700;

geninterrupt(0x15);
}





int e_avail(void)
{
/********************************************************/
/*							*/
/*		Get Extended Memory Size		*/
/*							*/
/*	Receives:  VOID					*/
/*							*/
/*	Returns:   number of Kbytes available		*/
/*							*/
/*	Globals used: None				*/
/*							*/
/********************************************************/
  _AH=0x88;
  geninterrupt(0x15);
}





void e_meminit(void)
{
/********************************************************/
/*							*/
/*	Initialize the Global Descriptor Structure	*/
/*							*/
/*	Receives: VOID					*/
/*							*/
/*	Returns:  VOID					*/
/*							*/
/*	Globals used: GDT structure			*/
/*							*/
/********************************************************/

  gdt.length_s = 0xffff;
  gdt.access_s = 0x93;
  gdt.tail_s   = 0;

  gdt.length_d = 0xffff;
  gdt.access_d = 0x93;
  gdt.tail_d   = 0;

}